"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _LruDb = _interopRequireDefault(require("@polkadot/db/engines/LruDb"));

var _TransactionDb = _interopRequireDefault(require("@polkadot/db/engines/TransactionDb"));

var _FileStructDb = _interopRequireDefault(require("./engines/FileStructDb"));

// Copyright 2017-2019 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
const LRU_SIZE = 8 * 1024;

class DiskDb extends _TransactionDb.default {
  constructor(base, name, options) {
    const backing = new _FileStructDb.default(base, name, options);
    super(options.isLru ? new _LruDb.default(backing, LRU_SIZE) : backing);
  }

}

exports.default = DiskDb;