"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = blockDb;

var _bn = _interopRequireDefault(require("../db/bn"));

var _u8a = _interopRequireDefault(require("../db/u8a"));

var _keys = _interopRequireDefault(require("./keys"));

// Copyright 2017-2019 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
function blockDb(db) {
  return {
    db,
    bestHash: (0, _u8a.default)(db, _keys.default.bestHash),
    bestNumber: (0, _bn.default)(db, _keys.default.bestNumber, 64),
    blockData: (0, _u8a.default)(db, _keys.default.blockByHash),
    header: (0, _u8a.default)(db, _keys.default.headerByHash),
    hash: (0, _u8a.default)(db, _keys.default.hashByNumber)
  };
}