import { BaseDb } from '@polkadot/db/types';
interface Base<T> {
    del(key: Uint8Array): void;
    get(key: Uint8Array): Uint8Array;
    set(key: Uint8Array, value: T, raw: Uint8Array): void;
    onUpdate(subscriber: (value: T, raw: Uint8Array) => void): void;
}
export default function base<T>(db: BaseDb): Base<T>;
export {};
