"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = decodeBn;

var _util = require("@polkadot/util");

var _base = _interopRequireDefault(require("./base"));

// Copyright 2017-2019 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
function decodeBn(db, createKey, bitLength) {
  const base = (0, _base.default)(db);
  return {
    del: keyParam => base.del(createKey(keyParam)),
    get: keyParam => (0, _util.u8aToBn)(base.get(createKey(keyParam)), true),
    set: (value, keyParam) => base.set(createKey(keyParam), value, (0, _util.bnToU8a)(value, bitLength, true)),
    onUpdate: updater => base.onUpdate(updater)
  };
}