"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _mkdirp = _interopRequireDefault(require("mkdirp"));

var _path = _interopRequireDefault(require("path"));

var _rimraf = _interopRequireDefault(require("rimraf"));

var _chainspec = require("@polkadot/chainspec");

var _TransactionDb = _interopRequireDefault(require("@polkadot/db/engines/TransactionDb"));

var _trieDb = _interopRequireDefault(require("@polkadot/trie-db"));

var _util = require("@polkadot/util");

var _ = _interopRequireDefault(require("."));

// Copyright 2017-2019 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
const KEY_A = new Uint8Array([0x10, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]);
const KEY_B = new Uint8Array([0x20, 2, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]);
const KEY_C = new Uint8Array([0x10, 2, 6, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]);
const KEY_D = new Uint8Array([0x10, 2, 6, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]);
const KEY_E = new Uint8Array([0x10, 2, 4, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]);
const KEY_F = new Uint8Array([0x50, 2, 4, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]);
const VAL_A = new Uint8Array([0x42, 1, 0x69]);
const VAL_B = new Uint8Array([0x42, 1, 2, 0x69]);
const VAL_C = new Uint8Array([0x42, 1, 2, 3, 0x69]);
const VAL_D = new Uint8Array([0x42, 1, 2, 3, 4, 0x69]);
const VAL_E = new Uint8Array([0x42, 1, 2, 3, 4, 5, 0x69]);
const VAL_F = new Uint8Array([0x42, 1, 2, 3, 4, 5, 6, 0x69]); // NOTE Skipped, doesn't seem to be too happy on CI (cwd issues?)

describe.skip('FileStructDb', () => {
  describe('basics', () => {
    const location = _path.default.join(process.cwd(), '--test-FileStructDb-basic');

    let store;

    const testGet = (key, value) => expect(store.get(key)).toEqual(value);

    beforeAll(() => {
      _mkdirp.default.sync(location);

      store = new _.default(location, 'testing', {
        isCompressed: false,
        isLru: false,
        isTrie: false
      });
      store.open();
    });
    afterAll(() => {
      store.close();

      _rimraf.default.sync(location);
    });
    it('writes an entry', () => {
      console.error('A: execute');
      store.put(KEY_A, VAL_A);
      console.error('A: expectations');
      testGet(KEY_A, VAL_A);
    });
    it('writes an entry (additional)', () => {
      console.error('B: execute');
      store.put(KEY_B, VAL_B);
      console.error('A: expectations');
      testGet(KEY_A, VAL_A);
      testGet(KEY_B, VAL_B);
    });
    it('writes an entry (expanding the tree)', () => {
      console.error('C: execute');
      store.put(KEY_C, VAL_C);
      console.error('C: expectations');
      testGet(KEY_A, VAL_A);
      testGet(KEY_B, VAL_B);
      testGet(KEY_C, VAL_C);
    });
    it('writes an entry (expanding the tree, again)', () => {
      console.error('D: execute');
      store.put(KEY_F, VAL_F);
      console.error('D: expectations');
      testGet(KEY_A, VAL_A);
      testGet(KEY_B, VAL_B);
      testGet(KEY_C, VAL_C);
      testGet(KEY_F, VAL_F);
    });
    it('writes an entry (expanding the tree, yet again)', () => {
      console.error('E: execute');
      store.put(KEY_E, VAL_E);
      console.error('E: expectations');
      testGet(KEY_A, VAL_A);
      testGet(KEY_B, VAL_B);
      testGet(KEY_C, VAL_C);
      testGet(KEY_E, VAL_E);
      testGet(KEY_F, VAL_F);
    });
    it('writes an entry, expanding the top-level', () => {
      console.error('F: execute');
      store.put(KEY_D, VAL_D);
      console.error('F: expectations');
      testGet(KEY_A, VAL_A);
      testGet(KEY_B, VAL_B);
      testGet(KEY_C, VAL_C);
      testGet(KEY_D, VAL_D);
      testGet(KEY_E, VAL_E);
      testGet(KEY_F, VAL_F);
    });
    it('overrides with smaller values', () => {
      console.error('G: execute');
      store.put(KEY_F, VAL_A);
      console.error('G: expectations');
      testGet(KEY_A, VAL_A);
      testGet(KEY_B, VAL_B);
      testGet(KEY_C, VAL_C);
      testGet(KEY_D, VAL_D);
      testGet(KEY_E, VAL_E);
      testGet(KEY_F, VAL_A);
    });
    it('overrides with larger values', () => {
      console.error('H: execute');
      store.put(KEY_A, VAL_F);
      console.error('H: expectations');
      testGet(KEY_A, VAL_F);
      testGet(KEY_B, VAL_B);
      testGet(KEY_C, VAL_C);
      testGet(KEY_D, VAL_D);
      testGet(KEY_E, VAL_E);
      testGet(KEY_F, VAL_A);
    });
  });
  describe('trie data', () => {
    const {
      genesis: {
        raw
      }
    } = _chainspec.alexander;

    const location = _path.default.join(process.cwd(), '--test-FileStructDb-trie-data');

    let store;
    beforeAll(() => {
      _mkdirp.default.sync(location);

      store = new _.default(location, 'testing', {
        isCompressed: false,
        isLru: false,
        isTrie: true
      });
      store.open();
    });
    afterAll(() => {
      store.close();

      _rimraf.default.sync(location);
    });
    it('stores all the values', () => {
      Object.entries(raw).forEach((_ref) => {
        let [key, val] = _ref;
        store.put((0, _util.hexToU8a)(key), (0, _util.hexToU8a)(val));
      });
    });
    describe('retrieves all the values', () => {
      Object.entries(raw).forEach((_ref2) => {
        let [key, val] = _ref2;
        it(key, () => {
          expect((0, _util.u8aToHex)(store.get((0, _util.hexToU8a)(key)))).toEqual(val);
        });
      });
    });
  });
  describe('via TrieDb', () => {
    class TestDb extends _TransactionDb.default {
      constructor(base, name) {
        super(new _.default(base, name, {
          isCompressed: false,
          isLru: false,
          isTrie: true
        }));
      }

    }

    const location = _path.default.join(process.cwd(), '--test-FileStructDb-trie-db');

    const {
      genesis: {
        raw
      },
      genesisRoot
    } = _chainspec.alexander;
    beforeAll(() => {
      _rimraf.default.sync(location);

      _mkdirp.default.sync(location);
    });
    it('creates a trie with the correct root', () => {
      console.error('TRIE: insert');
      const trie = new _trieDb.default(new TestDb(location, 'test.db'));
      trie.open();
      trie.transaction(() => {
        Object.entries(raw).forEach((_ref3) => {
          let [key, val] = _ref3;
          trie.put((0, _util.hexToU8a)(key), (0, _util.hexToU8a)(val));
        });
        return true;
      });
      expect((0, _util.u8aToHex)(trie.getRoot())).toEqual(genesisRoot);
    });
    describe('re-opens and has all the correct keys', () => {
      console.error('TRIE: retrieve');
      const trie = new _trieDb.default(new TestDb(location, 'test.db'));
      trie.open();
      trie.setRoot((0, _util.hexToU8a)(genesisRoot));
      Object.entries(raw).forEach((_ref4) => {
        let [key, val] = _ref4;
        it(key, () => {
          expect((0, _util.u8aToHex)(trie.get((0, _util.hexToU8a)(key)))).toEqual(val);
        });
      });
    });
  });
});