"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _Memory = _interopRequireDefault(require("@polkadot/db/Memory"));

var _trieDb = _interopRequireDefault(require("@polkadot/trie-db"));

var _util = require("@polkadot/util");

var _DiskDb = _interopRequireDefault(require("./DiskDb"));

var _block = _interopRequireDefault(require("./block"));

var _state = _interopRequireDefault(require("./state"));

// Copyright 2017-2019 @polkadot/client-chains authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
const BDB_OPT = {
  isCompressed: false,
  isLru: false,
  isTrie: false
};
const SDB_OPT = {
  isCompressed: false,
  isLru: false,
  isTrie: true
};

class Dbs {
  constructor(_ref, chain) {
    let {
      db,
      sync
    } = _ref;
    this.blocks = void 0;
    this.state = void 0;
    this.basePath = void 0;
    this.config = void 0;
    this.config = db;
    this.basePath = db.type !== 'memory' ? _path.default.join(db.path, 'chains', chain.id, (0, _util.u8aToHex)(chain.genesisRoot), 'db') : '';
    const isMemory = this.config.type === 'memory';
    const isLight = sync === 'light';
    this.blocks = (0, _block.default)(isMemory ? new _Memory.default() : new _DiskDb.default(this.basePath, isLight ? 'header' : 'block', BDB_OPT));
    this.state = (0, _state.default)(new _trieDb.default(isMemory || isLight ? new _Memory.default() : new _DiskDb.default(this.basePath, 'state', SDB_OPT)));
    this.blocks.db.open();
    this.state.db.open();
  }

  close() {
    this.blocks.db.close();
    this.state.db.close();
  }

}

exports.default = Dbs;