"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createState;

// Copyright 2017-2019 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
function createState(db) {
  // eslint-disable-next-line prefer-const
  let _db = db;
  return {
    get db() {
      return _db;
    },

    getRootEntry() {
      return _db.getEntry(_db.getRoot());
    },

    getRoot() {
      return _db.getRoot();
    },

    setRoot(root) {
      _db.setRoot(root);
    },

    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    snapshot(blockNumber) {// nothing, yet
    }

  };
}